
package de.ivu.elect.business.internet.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.internet.entity.InternetWidget;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractInternetWidgetEdit {

  @Inject
  protected InternetWidgetDAO dao;

  @Inject
  protected InternetWidgetExtendedDAO extendedDao;

  public void delete(InternetWidget entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(InternetWidget entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(InternetWidget entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected InternetWidget getAttachedEntity(InternetWidget entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected InternetWidget getAttachedAndRefreshedEntity(InternetWidget entity) {
    return dao.refresh(entity);
  }
}
